#ifndef LIST_MAP_H
#define LIST_MAP_H

/**************************************************
 *            the Beos Reversing Engine           * 
 *                    by Zadig                    *
 *                                                *
 * This file contains headers of the chain-lists  *
 * structures manipulation functions.             *
 **************************************************/
 
/***********************
 *  Mapping functions  *
 ***********************/ 
extern int32 LIST_GetLowerStringMap(LIST_Mapping *list, Mapping **result);
extern int32 LIST_GetLowerClassMap(LIST_Mapping *list, Mapping **result, uint8 *sz_ClassName);
extern int32 LIST_GetLowerMethodMap(LIST_Mapping *list, Mapping **result, uint8 *sz_ClassName);
extern int32 LIST_FreeMap(LIST_Mapping *list);
extern int32 LIST_DeleteMap(LIST_Mapping *list, Mapping *mapping);
extern int32 LIST_AddMap(LIST_Mapping *list, Mapping map);
extern int32 LIST_GetMappingAtAddr(LIST_Mapping *list, uint32 i_Addr, Mapping **map);

/*************************
 *  Reference functions  *
 *************************/ 
extern int32 LIST_FreeRef(LIST_Reference *list);
extern int32 LIST_DeleteRef(LIST_Reference *list, int32 i_Index);
extern int32 LIST_AppendRef(LIST_Reference *list, Reference ref);

#endif
