#ifndef GLOBALS_H
#define GLOBALS_H

#include <stdio.h>

/* defines for target specific code*/
#ifdef BEOS_TARGET /* BeOS compilation */

#define TMP_DIR         "/boot/var/tmp/"
#define CONFIG_FILE     "/boot/home/config/settings/RevEng_Settings"
#define HEADER_TARGET   "BeOS target    "

#else /* Generic compilation */

#define TMP_DIR         "/boot/var/tmp/"
#define CONFIG_FILE     "/boot/home/config/settings/RevEng_Settings"
#define HEADER_TARGET   "Generic target "

#endif
/* end defines for target specific code*/

/* ctag header */
#define CTAG_HEADER  "!_TAG_FILE_FORMAT	1	//\n\
!_TAG_FILE_SORTED	0	//\n\
!_TAG_PROGRAM_AUTHOR	Zadig	//\n\
!_TAG_PROGRAM_NAME	RevEng	//\n\
!_TAG_PROGRAM_URL	http://reveng.cjb.net	//\n\
!_TAG_PROGRAM_VERSION	%s	//\n"
                    
#define RE_VERSION "0.9.0"

#define STRING_MAX_SIZE 512     /* max size of a string */
#define REG_MAX_SIZE    16      /* max size of a register label */
#define MAX_SECTIONS    30      /* max sections in the file */
#define MAX_REFERENCES  50      /* max references of an object */
#define MAX_PLT_ENTRIES 1500    /* max plt entries in a file */
#define MAX_PARAMS      25      /* max params in a function */
#define MAX_REG_CNTX    200     /* max registers contexts backup */

#define RE_DISABLED     0xFFFFFFFF

#define RTTI_SYMBOL     "type_info" 
/* macros */
#define INT2STR(i)       ((uint32)( ( ((uint32)(i) & 0xFF) << 24) | \
                                    ( ((uint32)(i) & 0xFF0000) >> 8) |  \
                                    ( ((uint32)(i) & 0xFF00) << 8) | \
                                    ( ((uint32)(i) & 0xFF000000) >> 24) ) )

/* these 2 defines crash with optimization options (don't know why) */
#define STREQ3(s1,s2)    ( ( (*(uint32*)s1) & 0xFFFFFF) == ( (*(uint32*)s2) & 0xFFFFFF) )
#define STREQ4(s1,s2)    ( (*(uint32*)s1) == (*(uint32*)s2) )

/*#define STREQ3(s1,s2)    (strncmp((char*)(s1),s2,3) == 0)
#define STREQ4(s1,s2)    (strncmp((char*)(s1),s2,4) == 0)*/

/*globals variables*/
#ifdef FLG_DEBUG
extern FILE *dbgFile; /*debugging file*/
#endif

#endif
